# Paragraphs Table of Contents

If you have a long page built with paragraphs (as in the
[Paragraphs](https://www.drupal.org/project/paragraphs) module)
then you can use this to generate a table of contents for in-page navigation.

## Getting started

1. Install the module.
2. Go to Administration > Structure > Block (`/admin/structure/block`) and
   place the ToC block in a region. (If you are using the core Bartik theme,
   then the block should already be in the "Sidebar first" region.)
3. Create a node of type "Page with sections" (`node/add/page_with_sections`).
   Add at least one paragraph to the Sections field. Make the paragraphs long
   enough that the page will scroll.
4. Save and view your node. You should have a table of contents with a link to
   each paragraph that you have created.

## Adding a table of contents to another content type

For example, suppose you want to add a table of contents (ToC) to the "Basic
page" content type.

1. Go to Home > Administration > Structure > Content types > Page
   (`/admin/structure/types/manage/page/fields`).
2. Click the "Add field" button.
3. Under "Re-use an existing field", choose `field_ptoc_sections`.
4. Edit the "Table of contents" view
   (`/admin/structure/views/view/ptoc_table_of_contents`).
5. Adjust the "Filter criteria" to allow all content types, or at least Basic
   page.
6. Save the view.
7. Edit the ToC block
   (`/admin/structure/block/manage/views_block__ptoc_table_of_contents_block_1`).
8. Under "Content types", check off "Basic page".
9. Save the block.

Alternatively, add a second block display or clone the view. Then position the
new block from Administration > Structure > Block and configure it to appear
on the appropriate pages.

Note that the view uses a contextual filter. By default, this is hidden until
you expand the Advanced options while editing the view.

## Adding additional paragraph types

1. Edit the Sections field and check off the paragraph types you want to add.
2. Go to Home > Administration > Structure > Paragraphs types
   (`/admin/structure/paragraphs_type`) and choose "Manage display" for the
   additional paragraph types (one at a time).
3. Under "Custom display settings" check "Table of contents".
4. Configure the "Table of contents" view mode to show only the fields you
   want in the table of contents.

For most paragraph types, you will show only the title field in the table of
contents. If you want to show nested paragraphs in the table of contents, then
see how the Bundle paragraph type is configured.

## Deprecation warning

Most configuration provided by this module has machine names starting with
`ptoc_`. The following machine names may change before v1.0 is released.

- The "Page with sections" content type (`page_with_sections`).
- The "Table of contents" view mode for paragraphs (`paragraph.toc`).
- The "Table of contents" view mode for nodes (`node.ptoc_table_of_contents`).
`
